#include "stdafx.h"
#include "NeMessenger.h"
#include "DialPadDlg.h"
#include "DialPadManager.h"
#include "NeMessengerDlg.h"
#include "WorkGroupController.h"

#define ID_DIAL_INFO	(0xA017)

#define DP_COLOR_LIST_BORDER		(RGB(220,220,220))		// #dcdcdc
#define DP_COLOR_CALL_BTN_TEXT		(RGB(211, 221, 230))	// #d3dde6

#define DP_DLG_BTN_WIDTH			64
#define DP_DLG_BTN_HEIGHT			29
#define DP_DLG_BTN_GAP_X			4
#define DP_DLG_BTN_GAP_Y			4
#define DP_DLG_IPTBTN_WIDTH			47


IMPLEMENT_DYNAMIC(CDialPadDlg, CDialog)

CDialPadDlg::CDialPadDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDialPadDlg::IDD, pParent)
{
	m_bCalling = false;
}

CDialPadDlg::~CDialPadDlg()
{
	m_penBorder.DeleteObject();
}

void CDialPadDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_NUM1_BUTTON, m_btn1);
	DDX_Control(pDX, IDC_NUM2_BUTTON, m_btn2);
	DDX_Control(pDX, IDC_NUM3_BUTTON, m_btn3);
	DDX_Control(pDX, IDC_NUM4_BUTTON, m_btn4);
	DDX_Control(pDX, IDC_NUM5_BUTTON, m_btn5);
	DDX_Control(pDX, IDC_NUM6_BUTTON, m_btn6);
	DDX_Control(pDX, IDC_NUM7_BUTTON, m_btn7);
	DDX_Control(pDX, IDC_NUM8_BUTTON, m_btn8);
	DDX_Control(pDX, IDC_NUM9_BUTTON, m_btn9);
	DDX_Control(pDX, IDC_NUM0_BUTTON, m_btn0);
	DDX_Control(pDX, IDC_ASTERISK_BUTTON, m_btnAsterisk);
	DDX_Control(pDX, IDC_NUMBERSIGN_BUTTON, m_btnSharp);
	DDX_Control(pDX, IDC_MAKECALL_BUTTON, m_btnMakeCall);
	DDX_Control(pDX, IDC_CALLMEMO_BUTTON, m_btnMemo);
	DDX_Control(pDX, IDC_CLEARCONNECTION_BUTTON, m_btnEndCall);
	DDX_Control(pDX, IDC_CALLTRANSFER_BUTTON, m_btnTransferCall);
	DDX_Control(pDX, IDC_CONFERENCE_BUTTON, m_btnConfer);
}

BEGIN_MESSAGE_MAP(CDialPadDlg, CDialog)
	ON_CONTROL_RANGE(BN_CLICKED, IDC_NUM1_BUTTON, IDC_NUMBERSIGN_BUTTON, &CDialPadDlg::OnBnClickedNumPad)
	ON_BN_CLICKED(IDC_MAKECALL_BUTTON, &CDialPadDlg::OnBnClickedMakecallButton)
	ON_BN_CLICKED(IDC_CALLMEMO_BUTTON, &CDialPadDlg::OnBnClickedCallmemoButton)
	ON_BN_CLICKED(IDC_CLEARCONNECTION_BUTTON, &CDialPadDlg::OnBnClickedClearconnectionButton)
	ON_BN_CLICKED(IDC_CALLTRANSFER_BUTTON, &CDialPadDlg::OnBnClickedCalltransferButton)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CONFERENCE_BUTTON, &CDialPadDlg::OnBnClickedConferenceButton)
END_MESSAGE_MAP()


BOOL CDialPadDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	this->SetWindowText(LoadStringFromResource(IDS_DIALPAD_TITLE));

	InitControls();
	MoveWindow(0, 0, 240, 320);
	CenterWindow();
	InitSkin();
	ResizeCtrl();

	SetLastPosition(this, _T("DialpadDialog"));

	return TRUE;
}

void CDialPadDlg::OnBnClickedNumPad(UINT id)
{
	if (m_bCalling)
		return;

	switch (id)
	{
	case IDC_NUM1_BUTTON:		m_wndDialInfo.AddNumber(_T('1'));	break;
	case IDC_NUM2_BUTTON:		m_wndDialInfo.AddNumber(_T('2'));	break;
	case IDC_NUM3_BUTTON:		m_wndDialInfo.AddNumber(_T('3'));	break;
	case IDC_NUM4_BUTTON:		m_wndDialInfo.AddNumber(_T('4'));	break;
	case IDC_NUM5_BUTTON:		m_wndDialInfo.AddNumber(_T('5'));	break;
	case IDC_NUM6_BUTTON:		m_wndDialInfo.AddNumber(_T('6'));	break;
	case IDC_NUM7_BUTTON:		m_wndDialInfo.AddNumber(_T('7'));	break;
	case IDC_NUM8_BUTTON:		m_wndDialInfo.AddNumber(_T('8'));	break;
	case IDC_NUM9_BUTTON:		m_wndDialInfo.AddNumber(_T('9'));	break;
	case IDC_NUM0_BUTTON:		m_wndDialInfo.AddNumber(_T('0'));	break;
	case IDC_ASTERISK_BUTTON:	m_wndDialInfo.AddNumber(_T('*'));	break;
	case IDC_NUMBERSIGN_BUTTON:	m_wndDialInfo.AddNumber(_T('#'));	break;
	}
}

// ȭɱ
void CDialPadDlg::OnBnClickedMakecallButton()
{
	if (m_wndDialInfo.GetPhoneNumber().IsEmpty())
		return;

	GET_MESSENGER_DLG()->ProcPhoneCall(m_wndDialInfo.GetUserID(), m_wndDialInfo.GetPhoneNumber());

	m_bCalling = true;
	m_btnMakeCall.EnableWindow(FALSE);

	this->SetFocus();
}

// ȭ
void CDialPadDlg::OnBnClickedClearconnectionButton()
{
	ProcHangUp();

	this->SetFocus();
}

bool CDialPadDlg::ProcHangUp()
{
	if (NMessageBox(this, LoadStringFromResource(IDS_STRING609), _T("Ntalk Biz"), MB_YESNO) == IDYES)	// ٱ
	{
		g_pMessengerActor->RequestHangUp(g_pMessengerActor->GetUserID(), GET_MESSENGER_DLG()->GetCID());
		return true;
	}

	return false;
}

// ȭ޸
void CDialPadDlg::OnBnClickedCallmemoButton()
{
	GET_MESSENGER_DLG()->OnTopMenuManageCall();
}

// ȣȯ
void CDialPadDlg::OnBnClickedCalltransferButton()
{
	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this, ADD_USER_FROM_DIALPAD);
	
}

void CDialPadDlg::OnDestroy()
{
	CDialog::OnDestroy();

	if (m_wndDialInfo.GetSafeHwnd())
		m_wndDialInfo.DestroyWindow();
}

void CDialPadDlg::InitSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	// LosdSkin()   ׸    .
	//  ׸ ϱ ؼ SetWindowsTheme  ̿ؾ .
	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CDialPadDlg::ResizeCtrl()
{
	CRect rtClient(0, 0, 0, 0);
	GetClientRect(&rtClient);

	if (m_wndDialInfo.GetSafeHwnd())
	{
		CRect rtDialInfo(0, 0, 0, 0);
		rtDialInfo.left = 16;
		rtDialInfo.right = rtDialInfo.left + m_wndDialInfo.GetBGImage()->GetWidth() +30;
		rtDialInfo.top = 14;
		rtDialInfo.bottom = rtDialInfo.top + m_wndDialInfo.GetBGImage()->GetHeight();
		m_wndDialInfo.MoveWindow(rtDialInfo, TRUE);
	}

	if (m_btn1.GetSafeHwnd() || m_btn2.GetSafeHwnd() || m_btn3.GetSafeHwnd() ||
		m_btn4.GetSafeHwnd() || m_btn5.GetSafeHwnd() || m_btn6.GetSafeHwnd() ||
		m_btn7.GetSafeHwnd() || m_btn8.GetSafeHwnd() || m_btn9.GetSafeHwnd() ||
		m_btn0.GetSafeHwnd() || m_btnAsterisk.GetSafeHwnd() || m_btnSharp.GetSafeHwnd() || 
		m_btnMakeCall.GetSafeHwnd() || m_btnEndCall.GetSafeHwnd() || m_btnMemo.GetSafeHwnd() || 
		m_btnTransferCall.GetSafeHwnd())
	{
		int nSX = 16;
		int nSY = 97;

		CRect rtBtn(0, 0, 0, 0);
		rtBtn.left = nSX;
		rtBtn.right = rtBtn.left + DP_DLG_BTN_WIDTH;
		rtBtn.top = nSY;
		rtBtn.bottom = rtBtn.top + DP_DLG_BTN_HEIGHT;
		m_btn1.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn2.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn3.MoveWindow(rtBtn, TRUE);

		nSY += DP_DLG_BTN_HEIGHT + DP_DLG_BTN_GAP_Y;
		rtBtn.MoveToXY(nSX, nSY);
		m_btn4.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn5.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn6.MoveWindow(rtBtn, TRUE);

		nSY += DP_DLG_BTN_HEIGHT + DP_DLG_BTN_GAP_Y;
		rtBtn.MoveToXY(nSX, nSY);
		m_btn7.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn8.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn9.MoveWindow(rtBtn, TRUE);

		nSY += DP_DLG_BTN_HEIGHT + DP_DLG_BTN_GAP_Y;
		rtBtn.MoveToXY(nSX, nSY);
		m_btnAsterisk.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btn0.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_BTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btnSharp.MoveWindow(rtBtn, TRUE);

		nSY += DP_DLG_BTN_HEIGHT + DP_DLG_BTN_GAP_Y;
		rtBtn.MoveToXY(nSX, nSY);
		rtBtn.right = rtBtn.left + DP_DLG_IPTBTN_WIDTH;

		m_btnMakeCall.MoveWindow(rtBtn, TRUE);
		m_btnEndCall.MoveWindow(rtBtn, TRUE);
		m_btnEndCall.ShowWindow(SW_HIDE);
		rtBtn.OffsetRect(DP_DLG_IPTBTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btnTransferCall.ShowWindow(SW_SHOW);
		m_btnTransferCall.EnableWindow(FALSE);
		m_btnTransferCall.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_IPTBTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btnConfer.MoveWindow(rtBtn, TRUE);
		rtBtn.OffsetRect(DP_DLG_IPTBTN_WIDTH + DP_DLG_BTN_GAP_X, 0);
		m_btnMemo.MoveWindow(rtBtn, TRUE);

	}
}

void CDialPadDlg::InitControls()
{
	CString strTmpClassName;
	strTmpClassName.Format(_T("%s_%X%X%X"), _T("Ntalk_DialInfoWnd"), GetTickCount(), GetCurrentProcessId(), GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);
	m_wndDialInfo.Create(strTmpClassName, _T("Ntalk_DialInfoWnd"), WS_CHILD | WS_VISIBLE | /*WS_CLIPCHILDREN |*/ WS_CLIPSIBLINGS, CRect(0,0,0,0), this, ID_DIAL_INFO);

	m_penBorder.CreatePen(PS_SOLID, 1, DP_COLOR_LIST_BORDER);

	m_btnMakeCall.SetBtnBitmapFile(GetAppImgFile(_T("btn_D_ipt.bmp")), RGB(0,0,0));
	m_btnTransferCall.SetBtnBitmapFile(GetAppImgFile(_T("btn_D_ipt.bmp")), RGB(0,0,0));
	m_btnMemo.SetBtnBitmapFile(GetAppImgFile(_T("btn_D_ipt.bmp")), RGB(0,0,0));
	m_btnEndCall.SetBtnBitmapFile(GetAppImgFile(_T("btn_D_ipt.bmp")), RGB(0,0,0));
	m_btnConfer.SetBtnBitmapFile(GetAppImgFile(_T("btn_D_ipt.bmp")), RGB(0,0,0));

	m_btn1.SetFont(&g_ftDefault11PTB);
	m_btn2.SetFont(&g_ftDefault11PTB);
	m_btn3.SetFont(&g_ftDefault11PTB);
	m_btn4.SetFont(&g_ftDefault11PTB);
	m_btn5.SetFont(&g_ftDefault11PTB);
	m_btn6.SetFont(&g_ftDefault11PTB);
	m_btn7.SetFont(&g_ftDefault11PTB);
	m_btn8.SetFont(&g_ftDefault11PTB);
	m_btn9.SetFont(&g_ftDefault11PTB);
	m_btn0.SetFont(&g_ftDefault11PTB);
	m_btnAsterisk.SetFont(&g_ftDefault11PTB);
	m_btnSharp.SetFont(&g_ftDefault11PTB);

	m_btnMakeCall.SetBmpFont(&g_ftDefault8PT);
	m_btnMakeCall.SetBmpFontColor(DP_COLOR_CALL_BTN_TEXT);
	m_btnMakeCall.SetBmpText(LoadStringFromResource(IDS_STRING675));

	m_btnTransferCall.SetBmpFont(&g_ftDefault8PT);
	m_btnTransferCall.SetBmpFontColor(DP_COLOR_CALL_BTN_TEXT);
	m_btnTransferCall.SetBmpText(LoadStringFromResource(IDS_STRING676));

	m_btnMemo.SetBmpFont(&g_ftDefault8PT);
	m_btnMemo.SetBmpFontColor(DP_COLOR_CALL_BTN_TEXT);
	m_btnMemo.SetBmpText(LoadStringFromResource(IDS_STRING677));

	m_btnEndCall.SetBmpFont(&g_ftDefault8PT);
	m_btnEndCall.SetBmpFontColor(DP_COLOR_CALL_BTN_TEXT);
	m_btnEndCall.SetBmpText(LoadStringFromResource(IDS_STRING678));
	//m_btnEndCall.SetButtonDisable();
	m_btnEndCall.EnableWindow(FALSE);



	m_btnConfer.SetBmpFont(&g_ftDefault8PT);
	m_btnConfer.SetBmpFontColor(DP_COLOR_CALL_BTN_TEXT);
	m_btnConfer.SetBmpText(LoadStringFromResource(IDS_STRING679));
	//m_btnEndCall.SetButtonDisable();
	m_btnConfer.EnableWindow(FALSE);

}


void CDialPadDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// ȭ 

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	//  μ
	memDC.MoveTo(0, 0);
	memDC.LineTo(rcClient.right, 0);
/*
	CRect rcList(0, 0, 0, 0);
	m_lcUser.GetWindowRect(&rcList);
	ScreenToClient(rcList);
	rcList.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(rcList);
*/

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
}

BOOL CDialPadDlg::PreTranslateMessage(MSG* pMsg)
{
	if (IsCloseRequest(pMsg))
	{
		if (m_bCalling && ProcHangUp() != true )	// ȭ 
			return TRUE;

		CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

		if (pManager)
			pManager->DeleteView();

		return TRUE;
	}

	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_ESCAPE)
		{
			if (m_bCalling)
				ProcHangUp();

		}

		//  ̰ų ȭ  Ű  ʵ Ѵ.
		if (m_bCalling)
			return TRUE;

		if (pMsg->wParam == VK_RETURN)
		{
			OnBnClickedMakecallButton();
			return TRUE;
		}

		// Ű  쿡  ó.
		if (GetKeyState(VK_SHIFT) >= 0 && pMsg->wParam >= '0' && pMsg->wParam <= '9')
		{
			m_wndDialInfo.AddNumber(pMsg->wParam);
			return TRUE;
		}
		else if (GetKeyState(VK_SHIFT) < 0 && pMsg->wParam == '3')	// Shift + 3 = '#'
		{
			m_wndDialInfo.AddNumber(_T('#'));
			return TRUE;
		}
		else if (GetKeyState(VK_SHIFT) < 0 && pMsg->wParam == '8')	// Shift + 8 = '*'
		{
			m_wndDialInfo.AddNumber(_T('*'));
			return TRUE;
		}
		else if (pMsg->wParam >= VK_NUMPAD0 && pMsg->wParam <= VK_NUMPAD9)
		{
			m_wndDialInfo.AddNumber(pMsg->wParam - 0x30);
			return TRUE;
		}
		else if (pMsg->wParam == VK_MULTIPLY)
		{
			m_wndDialInfo.AddNumber(_T('*'));
			return TRUE;
		}
		else if (pMsg->wParam == VK_BACK)
		{
			m_wndDialInfo.OnBnClickedBackspace();
			return TRUE;
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

bool CDialPadDlg::IsCloseRequest( MSG* pMsg )
{
	bool result = false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) ||
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
		result = true;

	return result;
}

void CDialPadDlg::OnCallAlerting()
{
	if( m_wndDialInfo.GetSafeHwnd() != NULL )
	{
		m_wndDialInfo.SetCallStatus(itpstALERTING);
		m_btnEndCall.EnableWindow(TRUE);

		m_btnMakeCall.EnableWindow(FALSE);

		m_btnMakeCall.ShowWindow(SW_HIDE);
		m_btnEndCall.ShowWindow(SW_SHOW);
		m_bCalling = true;
	}
}

void CDialPadDlg::OnCallConnected()
{
	if( m_wndDialInfo.GetSafeHwnd() != NULL )
	{
		m_wndDialInfo.SetCallStatus(iptstACTIVE);
		m_btnEndCall.EnableWindow(TRUE);

		m_btnMakeCall.ShowWindow(SW_HIDE);
		m_btnEndCall.ShowWindow(SW_SHOW);
		m_btnTransferCall.EnableWindow(TRUE);
		m_btnConfer.EnableWindow(TRUE);
		m_bCalling = true;
	}
}

void CDialPadDlg::OnCallDisconnected()
{
	if( m_wndDialInfo.GetSafeHwnd() != NULL )
	{
		m_wndDialInfo.SetCallStatus(iptstIDLE);
		m_btnEndCall.EnableWindow(FALSE);

		m_btnEndCall.ShowWindow(SW_HIDE);
		m_btnMakeCall.ShowWindow(SW_SHOW);
		m_btnTransferCall.EnableWindow(FALSE);
		m_btnConfer.EnableWindow(FALSE);
		m_bCalling = false;
	}
}

void CDialPadDlg::SetCallInfo(NE_MEMBER_DATA userData, CString strTelNo)
{
	if (m_bCalling)
		return;

	m_wndDialInfo.SetMemberData(userData);
	m_wndDialInfo.SetCallNumber(strTelNo);
}

void CDialPadDlg::SetTransferUser(std::vector<NE_MEMBER_DATA>& vTransferUser)
{
	if (vTransferUser.size() != 1)
		return;

	std::vector<NE_MEMBER_DATA>::const_iterator iter = vTransferUser.begin();
	NE_MEMBER_DATA user = *iter;

	g_pMessengerActor->RequestCallTransfer(g_pMessengerActor->GetUserID(), user.strUserId.c_str());

	//// ȣ ȯ  ȭڴ ݴ´.
	//CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

	//if (pManager)
	//	pManager->DeleteView();
}


void CDialPadDlg::OnBnClickedConferenceButton()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this, ADD_USER_FROM_CONFERENCECALL);
}
